<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIdentifierPlace ArrayType
 * @subpackage Arrays
 */
class ArrayOfIdentifierPlace extends AbstractStructArrayBase
{
    /**
     * The IdentifierPlace
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdentifierPlace[]
     */
    public $IdentifierPlace;
    /**
     * Constructor method for ArrayOfIdentifierPlace
     * @uses ArrayOfIdentifierPlace::setIdentifierPlace()
     * @param \StructType\IdentifierPlace[] $identifierPlace
     */
    public function __construct(array $identifierPlace = array())
    {
        $this
            ->setIdentifierPlace($identifierPlace);
    }
    /**
     * Get IdentifierPlace value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdentifierPlace[]|null
     */
    public function getIdentifierPlace()
    {
        return isset($this->IdentifierPlace) ? $this->IdentifierPlace : null;
    }
    /**
     * This method is responsible for validating the values passed to the setIdentifierPlace method
     * This method is willingly generated in order to preserve the one-line inline validation within the setIdentifierPlace method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIdentifierPlaceForArrayConstraintsFromSetIdentifierPlace(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfIdentifierPlaceIdentifierPlaceItem) {
            // validation for constraint: itemType
            if (!$arrayOfIdentifierPlaceIdentifierPlaceItem instanceof \StructType\IdentifierPlace) {
                $invalidValues[] = is_object($arrayOfIdentifierPlaceIdentifierPlaceItem) ? get_class($arrayOfIdentifierPlaceIdentifierPlaceItem) : sprintf('%s(%s)', gettype($arrayOfIdentifierPlaceIdentifierPlaceItem), var_export($arrayOfIdentifierPlaceIdentifierPlaceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The IdentifierPlace property can only contain items of type \StructType\IdentifierPlace, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set IdentifierPlace value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierPlace[] $identifierPlace
     * @return \ArrayType\ArrayOfIdentifierPlace
     */
    public function setIdentifierPlace(array $identifierPlace = array())
    {
        // validation for constraint: array
        if ('' !== ($identifierPlaceArrayErrorMessage = self::validateIdentifierPlaceForArrayConstraintsFromSetIdentifierPlace($identifierPlace))) {
            throw new \InvalidArgumentException($identifierPlaceArrayErrorMessage, __LINE__);
        }
        if (is_null($identifierPlace) || (is_array($identifierPlace) && empty($identifierPlace))) {
            unset($this->IdentifierPlace);
        } else {
            $this->IdentifierPlace = $identifierPlace;
        }
        return $this;
    }
    /**
     * Add item to IdentifierPlace value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierPlace $item
     * @return \ArrayType\ArrayOfIdentifierPlace
     */
    public function addToIdentifierPlace(\StructType\IdentifierPlace $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IdentifierPlace) {
            throw new \InvalidArgumentException(sprintf('The IdentifierPlace property can only contain items of type \StructType\IdentifierPlace, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->IdentifierPlace[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IdentifierPlace|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IdentifierPlace|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IdentifierPlace|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IdentifierPlace|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IdentifierPlace|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IdentifierPlace
     */
    public function getAttributeName()
    {
        return 'IdentifierPlace';
    }
}
